package com.univ.abacomaya;

import java.util.ArrayList;
import java.util.List;
import java.util.Locale;

import com.univ.abacomaya.logic.Util;

import android.content.Context;
import android.content.Intent;
import android.content.res.Configuration;
import android.content.res.Resources;
import android.os.Bundle;
import android.support.v7.app.ActionBar;
import android.support.v7.app.ActionBarActivity;
import android.support.v7.widget.Toolbar;
import android.util.DisplayMetrics;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.BaseAdapter;
import android.widget.FrameLayout;
import android.widget.Spinner;
import android.widget.TextView;


@SuppressWarnings("deprecation")
public class MainActivity extends ActionBarActivity {
	
	 
	private List<String> mItems;
	FrameLayout fl;
	public static Context context;
    public static Resources s;
	
    private OnItemSelectedListener itemSelectedListener = new OnItemSelectedListener() {

		@Override
		public void onItemSelected(AdapterView<?> parent, View view,
				int position, long id) {
			switch(position){
			case 0:
			  getFragmentManager() .beginTransaction()
			  .replace(R.id.frame, new Fragment1()).commit();
			Constant.currentFragment=1;
			resetValues();
			return;
			
			case 1:
			   getFragmentManager().beginTransaction()
			   .replace(R.id.frame, new Fragment2()).commit();
			Constant.currentFragment=2;
			resetValues();
			return;
			
			case 2:
				getFragmentManager().beginTransaction()
			    .replace(R.id.frame, new Fragment3()).commit();
			Constant.currentFragment=3;
			resetValues();
			return;
			
			case 3:
				getFragmentManager().beginTransaction()
			    .replace(R.id.frame, new Fragment4()).commit(); 
			Constant.currentFragment=1;
			resetValues();
			return;
			}
		}

		@Override
		public void onNothingSelected(AdapterView<?> parent) {}};
	
 @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
       
        context = this;
        s = getResources();
        
        
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);
        View spinnerContainer = LayoutInflater.from(this).inflate(R.layout.toolbar_spinner,
        		toolbar, false);
        ActionBar.LayoutParams lp = new ActionBar.LayoutParams(
        		ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT);
        toolbar.addView(spinnerContainer, lp);

        fl = (FrameLayout)findViewById(R.id.frame);
       
        mItems = new ArrayList<String>();
       
        Adapt spinnerAdapter = new Adapt();
        spinnerAdapter.addItem(new String(s.getString(R.string.toolbar_a)));
        spinnerAdapter.addItem(new String(s.getString(R.string.toolbar_b)));
        spinnerAdapter.addItem(new String(s.getString(R.string.toolbar_c)));
        spinnerAdapter.addItem(new String(s.getString(R.string.toolbar_d)));
        
        Spinner spinner = (Spinner) spinnerContainer.findViewById(R.id.toolbar_spinner);
        spinner.setAdapter(spinnerAdapter);
        
        spinner.setOnItemSelectedListener(itemSelectedListener);
       
       getFragmentManager().beginTransaction()
       .replace(R.id.frame, new Fragment1()).commit();
       Constant.currentFragment=1;
    
 }
 

 @Override
 public boolean onCreateOptionsMenu(Menu menu) {
     getMenuInflater().inflate(R.menu.menu, menu);
     return true;
 }
 
 @Override
	public boolean onOptionsItemSelected(MenuItem item) {
	    switch (item.getItemId()) {
	    
	    case R.id.m_reset:
	    	if (Constant.currentFragment==1){
	    		Util.resetValues(MainActivity.this, new Fragment1());
	    	}
	    	else if (Constant.currentFragment==2){
	    		Util.resetValues(MainActivity.this, new Fragment2());
	    	}
            else if (Constant.currentFragment==3){
            	Util.resetValues(MainActivity.this, new Fragment3());
	    	}
            else if (Constant.currentFragment==4){
            	Util.resetValues(MainActivity.this, new Fragment4());
	        }
	    	return true;
	       
	/*    case R.id.m_en:
	    	setLocale("en");
	    	Constant.locale="en";
	    	return true;
	    	
	    case R.id.m_it:
	    	setLocale("it");
	    	Constant.locale="it";
	    	return true ;*/
	    	
	    
	        
	    default:
	        return super.onOptionsItemSelected(item);
	    }
	}
  
 /*change language at Run-time*/
//use method like that:
//setLocale("en");
public void setLocale(String lang) { 
	Locale myLocale = new Locale(lang); 
	Resources res = getResources(); 
	DisplayMetrics dm = res.getDisplayMetrics(); 
	Configuration conf = res.getConfiguration(); 
	conf.locale = myLocale; 
	res.updateConfiguration(conf, dm); 
	Intent refresh = new Intent(this, MainActivity.class); 
	startActivity(refresh); 
	this.finish();
}



   
    
    private class Adapt extends BaseAdapter {
    		
        public void addItem(String d) {
    		if (d!=null){
    		mItems.add(d); }
    	}
        
        @Override
    	public int getCount() {
    		return mItems.size();
    	}

    	@Override
    	public Object getItem(int position) {
    		return mItems.get(position);
    	}

    	@Override
    	public long getItemId(int position) {
    		return position;
    	}

    	@Override
    	public View getDropDownView(int position, View view, ViewGroup parent) {
    		if (view == null || !view.getTag().toString().equals("DROPDOWN")) {
    			view = getLayoutInflater().inflate(R.layout.toolbar_spinner_item_dropdown, parent, false);
    			view.setTag("DROPDOWN");
    		}

    		TextView textView = (TextView) view.findViewById(android.R.id.text1);
    		textView.setText(getTitle(position));

    		return view;
    	}

    	@Override
    	public View getView(int position, View view, ViewGroup parent) {
    		if (view == null || !view.getTag().toString().equals("NON_DROPDOWN")) {
    			view = getLayoutInflater().inflate(R.layout.
    					toolbar_spinner_item_actionbar, parent, false);
    			view.setTag("NON_DROPDOWN");
    		}
    		TextView textView = (TextView) view.findViewById(android.R.id.text1);
    		textView.setText(getTitle(position));
    		return view;
    	}

    	private String getTitle(int position) {
    		return position >= 0 && position < mItems.size() ? mItems.get(position) : "";
    	}
    }
    /**
     * Resetta tutti i valori 
     */
    public static void resetValues(){
   	 Constant.v2_1=0; Constant.v2_2=0; Constant.v2_3=0; Constant.v2_4=0; Constant.v3_1=0; Constant.v3_2=0;
		Constant.v3_3=0; Constant.v3_4=0; Constant.v4_1=0; Constant.v4_2=0; Constant.v4_3=0; Constant.v4_4=0;
		Constant.v1=0; Constant.v2=0; Constant.v3=0; Constant.v4=0;
		Constant.s1=0; Constant.s2=0; Constant.s3=0; Constant.s4=0; 
		Constant.v1s=0; Constant.v2s=0; Constant.v3s=0; Constant.v4s=0; 
		Constant.v1v=0;  Constant.v2v=0;  Constant.v3v=0;  Constant.v4v=0;
		Constant.currentValue=0; Constant.maxStep=0; Constant.currentStep=0;
		Constant.k1_a1=0; Constant.k1_a2=0; Constant.k2_a1=0; Constant.k2_a2=0;
		Constant.k3_a1=0; Constant.k3_a2=0; Constant.k4_a1=0; Constant.k4_a2=0;
		Constant.k5_a1=0; Constant.k5_a2=0; Constant.k6_a1=0; Constant.k16_a1=0; 
		Constant.k6_a2=0; Constant.k7_a1=0; Constant.k7_a2=0; Constant.k16_a2=0;
		Constant.k8_a1=0; Constant.k8_a2=0; Constant.k9_a1=0; Constant.k9_a2=0;
		Constant.k10_a1=0; Constant.k10_a2=0; Constant.k11_a1=0; Constant.k11_a2=0;
		Constant.k12_a1=0; Constant.k12_a2=0; Constant.k13_a1=0; Constant.k13_a2=0;
		Constant.k14_a1=0; Constant.k14_a2=0; Constant.k15_a1=0; Constant.k15_a2=0;
		Constant.moltResult=0; Constant.subResult=0; Constant.sumResult=0;
    }
   
}
